Articles in this section

How to implement show/hide HTML template content on node click in JavaScript Diagram?

This article explains how to implement show/hide HTML template content on node click in a JavaScript Diagram. In The Syncfusion® JavaScript Diagram control offers support for rendering HTML template content on nodes, enabling seamless integration of dynamic content. In this article, we will demonstrate rendering multiple contents within a single HTML node and adjusting their visibility upon clicking the node.

Rendering HTML Template Nodes in Syncfusion® Diagram:

HTML elements can be incorporated into the diagram using the HTML-type node. The shape property of the node enables you to specify the type of node. The following code exemplifies the creation of an HTML node with a template.

<script
  id="nodeTemplate" type="text/x-template">
        <div id="parent">
    
            <p>Accounting Document
  Fact</p>
            <hr id="line"
  style="visibility:hidden">
            <div id="Sub_Child"
  style="width:50%height:75%;margin-right:
  20px;visibility:hidden">
                <p> Billing Type Code</p>
                <p> Billing Type
  </p>
                <p> Billing Description
  </p>
            </div>
        </div>
    </script>

We have implemented the functionality to show/hide the HTML template content based on a node click.

function showHide() {
        if
  (diagram.selectedItems.nodes.length > 0) {
            let element =
  document.getElementById("Sub_Child");
            let pElement =
  document.getElementById("parent");
            let line =
  document.getElementById("line");
          if
  (diagram.selectedItems.nodes[0].addInfo[0].show === "Hide") {
           
            element.style.visibility =
  "visible";
            line.style.visibility =
  "visible";
            pElement.style.height =
  "133px";
           
  diagram.selectedItems.nodes[0].height = 133;
            
  diagram.selectedItems.nodes[0].offsetY = 250;
           
  diagram.selectedItems.nodes[0].addInfo[0].show = "Visible";
            diagram.dataBind();
          } else {
            
            pElement.style.height =
  "30px";
            element.style.visibility =
  "hidden";
            line.style.visibility =
  "hidden";
            
  diagram.selectedItems.nodes[0].height = 30;
            
  diagram.selectedItems.nodes[0].offsetY = 200;
           
  diagram.selectedItems.nodes[0].addInfo[0].show = "Hide";
            diagram.dataBind();
          }
        }
}

Here the showHide method is triggered when the parent div is clicked. It checks the visibility state of an inner div named ‘Sub_Child’ and toggles its visibility along with associated elements such as ‘parent’ and ‘line’. The method dynamically adjusts the height and offset properties of the selected node based on its current visibility state, providing a simple way to show or hide HTML template content on node click. Refer to the following sample for more information.


Refer to the working sample for additional details and implementation: Click here for sample

 

Conclusion

We hope you enjoyed learning about how to implement show/hide HTML template content on node click in JavaScript Diagram.

You can refer to our JavaScript Diagram feature tour page to know about its other groundbreaking feature representations and documentation, and how to quickly get started for configuration specifications.  You can also explore our JavaScript Diagram example to understand how to create and manipulate data.

For current customers, you can check out our components from the License and Downloads page. If you are new to Syncfusion®, you can try our 30-day free trial to check out our other controls.

If you have any queries or require clarifications, please let us know in the comments section below. You can also contact us through our support forumsBoldDesk Support, or feedback portal. We are always happy to assist you!









Did you find this information helpful?
Yes
No
Help us improve this page
Please provide feedback or comments
Comments (0)
Access denied
Access denied

Articles in this section

How to implement show/hide HTML template content on node click in React Diagram?

This article explains how to implement show/hide HTML template content on node click in React Diagram. The Syncfusion® React Diagram control offers support for rendering HTML template content on nodes, enabling seamless integration of dynamic content. In this article, we will demonstrate rendering multiple contents within a single HTML node and adjusting their visibility upon clicking the node.

Rendering HTML Template Nodes in Syncfusion® Diagram:

HTML elements can be incorporated into the diagram using the HTML-type node. The shape property of the node enables you to specify the type of node. The following code exemplifies the creation of an HTML node with a template.


 function nodeTemplate(data) {
   return (
     <div id="parent" onClick={showHide}>
       <p>Accounting Document Fact</p>
       <hr id="line" style={{ visibility: 'hidden' }} />
       <div
         id="Sub_Child"
         style={{
           width: '50%',
           height: '75%',
           marginRight: '20px',
           visibility: 'hidden',
         }}
       >
         <p style={{ whiteSpace: 'nowrap' }}>Billing Type Code</p>
         <p style={{ whiteSpace: 'nowrap' }}>Billing Type</p>
         <p style={{ whiteSpace: 'nowrap' }}>Billing Description</p>
       </div>
     </div>
   );
 } 

 return (
   <div className="control-pane">
     <style>{SAMPLE_CSS}</style>
     <div className="col-lg-8 control-section">
       <div className="content-wrapper" style={{ width: '100%' }}>
         <DiagramComponent
           id="diagram"
           ref={(diagram) => (diagramInstance = diagram)}
           width={'100%'}
           height={'645px'}
           nodes={nodes}
           nodeTemplate={nodeTemplate}
         >
           <Inject services={[UndoRedo]} />
         </DiagramComponent>
       </div>
     </div>
   </div>
 ); 

We have implemented the functionality to show/hide the HTML template content based on a node click.

 function showHide() {
   const selectedNode = diagramInstance.selectedItems.nodes[0];

   if (selectedNode) {
     const element = document.getElementById('Sub_Child');
     const pElement = document.getElementById('parent');
     const line = document.getElementById('line');

     if (selectedNode.addInfo[0].show === 'Hide') {
       element.style.visibility = 'visible';
       line.style.visibility = 'visible';
       pElement.style.height = '133px';
       selectedNode.height = 133;
       selectedNode.offsetY = 250;
       selectedNode.addInfo[0].show = 'Visible';
     } else {
       pElement.style.height = '30px';
       element.style.visibility = 'hidden';
       line.style.visibility = 'hidden';
       selectedNode.height = 30;
       selectedNode.offsetY = 200;
       selectedNode.addInfo[0].show = 'Hide';
     }

     diagramInstance.dataBind();
   }
 } 

Here the showHide method is triggered when the parent div is clicked. It checks the visibility state of an inner div named ‘Sub_Child’ and toggles its visibility along with associated elements such as ‘parent’ and ‘line’. The method dynamically adjusts the height and offset properties of the selected node based on its current visibility state, providing a simple way to show or hide HTML template content on node click. Refer to the following sample for more information.

Sample:

Refer to the working sample for additional details and implementation: Click here for sample

Conclusion

We hope you enjoyed learning about how to implement show/hide HTML template content on node click in React Diagram.

You can refer to our React Diagram feature tour page to learn about its other groundbreaking feature representations and documentation. You can also explore our React Diagram example to understand how to present and manipulate data.

For current customers, you can check out our components from the License and Downloads page. If you are new to Syncfusion®, you can try our 30-day free trial to check out our React Diagram and other components.

If you have any queries or require clarifications, please let us know in comments below. You can also contact us through our support forums, BoldDesk Support, or feedback portal. We are always happy to assist you!

Did you find this information helpful?
Yes
No
Help us improve this page
Please provide feedback or comments
Comments (0)
Access denied
Access denied

Articles in this section

How to implement show/hide HTML template content on node click in Vue Diagram?

The Syncfusion® Vue Diagram control offers support for rendering HTML template content on nodes, enabling seamless integration of dynamic content. In this article, we will demonstrate rendering multiple contents within a single HTML node and adjusting their visibility upon clicking the node.

Rendering HTML Template Nodes in Syncfusion® Diagram:

HTML elements can be incorporated into the diagram using the HTML-type node. The shape property of the node enables you to specify the type of node. The following code exemplifies the creation of an HTML node with a template.



// template.vue file
<template>
 <div v-if="data.id === 'node1Template'">
   <div id="parent">
     <p>Accounting Document Fact</p>
     <hr id="line" :style="{ visibility: showLine ? 'visible' : 'hidden' }" />
     <div
       id="Sub_Child"
       :style="{
         visibility: showSubChild ? 'visible' : 'hidden',
         width: '50%',
         height: '75%',
         marginRight: '20px',
       }"
     >
       <p :style="{ whiteSpace: 'nowrap' }">Billing Type Code</p>
       <p :style="{ whiteSpace: 'nowrap' }">Billing Type</p>
       <p :style="{ whiteSpace: 'nowrap' }">Billing Description</p>
     </div>
   </div>
 </div>
</template>


// App.vue file
<template>
 <div class="control-section">
   <div id="custom-diagram" class="control-section">
     <ejs-diagram
       style="display: block"
       ref="diagramObj"
       id="diagram"
       :width="width"
       :backgroundColor="backgroundColor"
       :nodeTemplate="nodeTemplate"
       :height="height"
       :nodes="nodes"
     ></ejs-diagram>
   </div>
 </div>
</template>

<script>
import NodeTemplate from './template.vue';
export default {
 components: {
   'ejs-diagram': DiagramComponent,
 },
 data: function () {
   return {
     nodeTemplate: function () {
       return {
         template: createApp({}).component('nodeTemplate', NodeTemplate),
       };
     },
     width: '100%',
     height: '1000px',
     nodes: nodes,
     backgroundColor: '#f5f5f5',
   };
 },
 }
 </script>

We have implemented the functionality to show/hide the HTML template content based on a node click.

   parent.onclick = () => {
     const selectedNode = diagramInstance.selectedItems.nodes[0];

     if (selectedNode) {
       const element = document.getElementById('Sub_Child');
       const pElement = document.getElementById('parent');
       const line = document.getElementById('line');

       if (selectedNode.addInfo[0].show === 'Hide') {
         element.style.visibility = 'visible';
         line.style.visibility = 'visible';
         pElement.style.height = '133px';
         selectedNode.height = 133;
         selectedNode.offsetY = 250;
         selectedNode.addInfo[0].show = 'Visible';
       } else {
         pElement.style.height = '30px';
         element.style.visibility = 'hidden';
         line.style.visibility = 'hidden';
         selectedNode.height = 30;
         selectedNode.offsetY = 200;
         selectedNode.addInfo[0].show = 'Hide';
       }

       diagramInstance.dataBind();
     }
   };

Here, the showHide method is triggered when the parent div is clicked. It checks the visibility state of an inner div named ‘Sub_Child’ and toggles its visibility along with associated elements such as ‘parent’ and ‘line’. The method dynamically adjusts the height and offset properties of the selected node based on its current visibility state, providing a simple way to show or hide HTML template content on node click. Refer to the following sample for more information.

Sample:

Refer to the working sample for additional details and implementation: Click here for sample

Conclusion

We hope you enjoyed learning about how to implement show/hide HTML template content on node click in Vue Diagram.

You can refer to our Vue Diagram feature tour page to learn about its other groundbreaking feature representations and documentation, and how to quickly get started for configuration specifications. You can also explore our Vue Diagram example to understand how to create and manipulate data.

For current customers, you can check out our components from the License and Downloads page. If you are new to Syncfusion®, you can try our 30-day free trial to check out our other controls.

If you have any queries or require clarifications, please let us know in the comments section below. You can also contact us through our support forums, BoldDesk Support, or feedback portal. We are always happy to assist you!

Did you find this information helpful?
Yes
No
Help us improve this page
Please provide feedback or comments
Comments (0)
Access denied
Access denied